/*

Copyright 1990 by Cray Research, Inc.

Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of Cray Research, Inc. not be used in
advertising or publicity pertaining to distribution of the software without
specific, written prior permission.  Cray Research, Inc. makes no
representations about the suitability of this software for any purpose.  It
is provided "as is" without express or implied warranty.

*/

static char defs_h_rcsid[]="$Id: defs.h,v 1.15 92/09/29 17:17:34 bobo Exp $";

#include <X11/Intrinsic.h>

#define MAXHEADERS	200
#define MAXMESLEN	2024
#define MAXFILES	2024

#ifdef CRAY
#define MAXPATHLEN 160
#endif

#ifndef SIGCLD 
#define SIGCLD SIGCHLD
#endif

#ifndef DEFAULT_HELPFILE
#define DEFAULT_HELPFILE "/usr/lib/X11/xmailtool.help"
#endif

#define GRIPE_MSG "To: bobo@pecan.cray.com\nSubject: Xmailtool Problem\n\n\
I would like to register the following complaint:\n\n"



#define asciiStringWidgetClass asciiTextWidgetClass

struct msg_header {
	char cur;
	char stat;
			/* if the message is new and/or unread, the actual
			 * number of characters sent by mail will differ as
			 * follows:
			 *  N : off by 10 characters.
			 *  U : off by  1 characters.
			 */
	int num;
	char data[300];
	struct msg_header *next,*prev;
};

struct _app_resources {
	Boolean autoHelp;
	Boolean cmdBox;
	Boolean stateBox;
	int interval;
	char *patchLevel;
	char *file;
	char *helpFile;
	char *iconGeometry;
	Cursor norm,wait,show,delete,save,preserve;
};

struct outbound_msg {
	Widget box,text;
	char *file;
};

struct proc_msg {
	char *file;
	int pid;
	Widget box,text;
	struct proc_msg *next;
	time_t mtime;
};

typedef struct {
	String string;
	int list_index;
	String data;
} myListReturnStruct;
